# python list vs tuples assignment

# python allocates memory to tuples in larger blocks with low overhead as they are immutable
# tuples can contain elements belonging to different data-types
# tuples cannot be copied
# tuples have fixed length i.e. you cannot change the size of an existing tuple
tuple_cars = ('dynamics', 'tynamics', 'alabaster', 10)
print('tuple = {}'.format(tuple_cars))
print('size of tuple = {}'.format(tuple_cars.__sizeof__()))

print('\n')

# immutable tuples
# tuples does not support item assignment
# below print statement will throws an exception. uncomment it to see the effect
# tuple_cars[0] = 'Supremacy'

print('\n')

# python allocates memory to list in smaller blocks
# list can contain elements belonging to same data-type
# list have variable length
list_cars = ['dynamics', 'tynamics', 'alabaster', 'Bolt']
print('list = {}'.format(list_cars))
print('size of list = {}'.format(list_cars.__sizeof__()))

print('\n')

# mutable list
list_cars[0] = 'mystery'
print('updated list = {}'.format(list_cars))
